/*
 * @Cameron Giarrusso APCS Game Apr 6, 2017
 */
package Monopoly;

import Monopoly.Board.Board;
import Monopoly.Board.Space.Space;
import Monopoly.Board.Space.Special;
import Monopoly.Rolls.Roll;

/**
 *
 * @author fcg
 */
public class Game {

    private int rolls = 0;
    private int moves = 0;
    private int position = 0;
    private int pastGo = 0;
    private int distance = 0;
    private int doubles = 0;
    private int doublesInARow = 0;
    private int jailsInARow = 0;
    private int rollsInJail = 0;
    private boolean inJail = false;
    private Board board;
    private Roll roll;


    public void turn() {
        if (inJail) {
            unjail();
            return;
        }
        distance += roll.roll();
        rolls++;
        if (roll.isDoubles()) {
            doubles++;
            doublesInARow++;
                    if (doublesInARow >= 3) {
                        jail();
                        return;
                    }
        }
        move(); 
        if(roll.isDoubles()) turn();
    }

    public void move() {
        int temp = position;
        moves++;
        position = distance%40;
        if (temp > position) pastGo++;
        Space space = board.getSpace(position);
        space.addLanded();
    }

    public void jail() {
        inJail = true;
        jailsInARow = 0;
    }

    public void unjail() {
        jailsInARow++;
        rollsInJail++;
        roll.roll();
        rolls++;
        if(roll.isDoubles()){
            distance += roll.getRoll();
            move();
            inJail = false;
        }
        else if(jailsInARow >= 3){ distance += roll.getRoll(); move(); inJail = false;}
        else unjail();
    }

//    public boolean monopoly(int player, int[] ownership) {
//        Space check = board.getSpace(position);
//        check.isOwnable();
//    }

    public Special getNearestUtility() {
        return board.getNearestUtility(position);
    }

    public Special getNearestRailroad() {
        return board.getNearestRailroad(position);
    }

    public Game() {
        this.board = new Board();
        this.roll = new Roll();
    }

    public int getRolls() {
        return rolls;
    }

    public int getMoves() {
        return moves;
    }

    public int getPosition() {
        return position;
    }

    public int getDistance(){
        return distance;
    }
    
    public int getDoubles() {
        return doubles;
    }
    
    public int getDoublesInARow() {
        return doublesInARow;
    }

    public int getJailsInARow() {
        return jailsInARow;
    }
    
    public int getRollsInJail(){
        return rollsInJail;
    }
    
    public boolean getInJail(){
        return inJail;
    }

    public Board getBoard(){
        return board;
    }
    
    public Roll getRoll() {
        return roll;
    }
    
    public int getPastGo(){
        return pastGo;
    }

}
